diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/qos-txop.cc ns-3.36/src/wifi/model/qos-txop.cc
--- ns-3.35/src/wifi/model/qos-txop.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/qos-txop.cc	2022-04-30 18:23:58.210735000 -0700
@@ -308,7 +308,7 @@
   // TODO Add a WifiMacQueue method that serves this purpose; IsEmpty () can
   // then reuse such method.
   m_queue->IsEmpty ();
-  bool queueIsNotEmpty = (m_queue->PeekFirstAvailable (m_qosBlockedDestinations) != m_queue->end ());
+  bool queueIsNotEmpty = (m_queue->PeekFirstAvailable (m_qosBlockedDestinations) != nullptr);
 
   bool ret = (baManagerHasPackets || queueIsNotEmpty);
   NS_LOG_FUNCTION (this << baManagerHasPackets << queueIsNotEmpty);
@@ -354,61 +354,61 @@
 }
 
 Ptr<const WifiMacQueueItem>
-QosTxop::PeekNextMpdu (uint8_t tid, Mac48Address recipient)
+QosTxop::PeekNextMpdu (uint8_t tid, Mac48Address recipient, Ptr<const WifiMacQueueItem> item)
 {
-  return PeekNextMpdu (WifiMacQueue::EMPTY, tid, recipient);
-}
-
-Ptr<const WifiMacQueueItem>
-QosTxop::PeekNextMpdu (WifiMacQueueItem::ConstIterator queueIt, uint8_t tid, Mac48Address recipient)
-{
-  NS_LOG_FUNCTION (this << +tid << recipient);
+  NS_LOG_FUNCTION (this << +tid << recipient << item);
 
   // lambda to peek the next frame
-  auto peek = [this, &tid, &recipient, &queueIt] () -> WifiMacQueue::ConstIterator
+  auto peek = [this, &tid, &recipient, &item] () -> Ptr<const WifiMacQueueItem>
     {
       if (tid == 8 && recipient.IsBroadcast ())  // undefined TID and recipient
         {
-          return m_queue->PeekFirstAvailable (m_qosBlockedDestinations, queueIt);
+          return m_queue->PeekFirstAvailable (m_qosBlockedDestinations, item);
         }
       if (m_qosBlockedDestinations->IsBlocked (recipient, tid))
         {
-          return m_queue->end ();
+          return nullptr;
         }
-      return m_queue->PeekByTidAndAddress (tid, recipient, queueIt);
+      return m_queue->PeekByTidAndAddress (tid, recipient, item);
     };
 
-  queueIt = peek ();
+  item = peek ();
   // remove old packets (must be retransmissions or in flight, otherwise they did
   // not get a sequence number assigned)
-  while (queueIt != m_queue->end () && !(*queueIt)->IsFragment ())
+  while (item != nullptr && !item->IsFragment ())
     {
-      if (((*queueIt)->GetHeader ().IsRetry () || (*queueIt)->IsInFlight ())
-          && IsQosOldPacket (*queueIt))
+      if ((item->GetHeader ().IsRetry () || item->IsInFlight ())
+          && IsQosOldPacket (item))
         {
-          NS_LOG_DEBUG ("Removing an old packet from EDCA queue: " << **queueIt);
+          NS_LOG_DEBUG ("Removing an old packet from EDCA queue: " << *item);
           if (!m_droppedMpduCallback.IsNull ())
             {
-              m_droppedMpduCallback (WIFI_MAC_DROP_QOS_OLD_PACKET, *queueIt);
+              m_droppedMpduCallback (WIFI_MAC_DROP_QOS_OLD_PACKET, item);
             }
-          queueIt = m_queue->Remove (queueIt);
-          queueIt = peek ();
+          auto oldItem = item;
+          item = peek ();
+          m_queue->Remove (oldItem);
+        }
+      else if (item->IsInFlight ())
+        {
+          NS_LOG_DEBUG ("Skipping in flight MPDU: " << *item);
+          item = peek ();
         }
-      else if ((*queueIt)->IsInFlight ())
+      else if (item->GetHeader ().HasData ()
+               && !m_mac->CanForwardPacketsTo (item->GetHeader ().GetAddr1 ()))
         {
-          NS_LOG_DEBUG ("Skipping in flight MPDU: " << **queueIt);
-          ++queueIt;
-          queueIt = peek ();
+          NS_LOG_DEBUG ("Skipping frame that cannot be forwarded: " << *item);
+          item = peek ();
         }
       else
         {
           break;
         }
     }
-  if (queueIt != m_queue->end ())
+  if (item != nullptr)
     {
-      NS_ASSERT (!(*queueIt)->IsInFlight ());
-      WifiMacHeader& hdr = (*queueIt)->GetHeader ();
+      NS_ASSERT (!item->IsInFlight ());
+      WifiMacHeader& hdr = item->GetItem ()->GetHeader ();
 
       // peek the next sequence number and check if it is within the transmit window
       // in case of QoS data frame
@@ -423,25 +423,25 @@
               && !IsInWindow (sequence, GetBaStartingSequence (recipient, tid), GetBaBufferSize (recipient, tid)))
             {
               NS_LOG_DEBUG ("Packet beyond the end of the current transmit window");
-              return 0;
+              return nullptr;
             }
         }
 
       // Assign a sequence number if this is not a fragment nor a retransmission
-      if (!(*queueIt)->IsFragment () && !hdr.IsRetry ())
+      if (!item->IsFragment () && !hdr.IsRetry ())
         {
           hdr.SetSequenceNumber (sequence);
         }
-      NS_LOG_DEBUG ("Packet peeked from EDCA queue: " << **queueIt);
-      return *queueIt;
+      NS_LOG_DEBUG ("Packet peeked from EDCA queue: " << *item);
+      return item;
     }
 
-  return 0;
+  return nullptr;
 }
 
 Ptr<WifiMacQueueItem>
 QosTxop::GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                      Time availableTime, bool initialFrame, WifiMacQueueItem::ConstIterator& queueIt)
+                      Time availableTime, bool initialFrame)
 {
   NS_ASSERT (peekedItem != 0);
   NS_ASSERT (m_qosFem != 0);
@@ -461,9 +461,6 @@
     }
 
   NS_ASSERT (peekedItem->IsQueued ());
-  WifiMacQueueItem::ConstIterator peekedIt = peekedItem->GetQueueIterator ();
-  NS_ASSERT ((*peekedIt)->GetPacket () == peekedItem->GetPacket ());
-  NS_ASSERT ((*peekedIt)->GetQueueAc () == m_ac);
   Ptr<WifiMacQueueItem> mpdu;
 
   // If it is a non-broadcast QoS Data frame and it is not a retransmission nor a fragment,
@@ -486,7 +483,7 @@
           && !peekedItem->IsInFlight ())
         {
           Ptr<HtFrameExchangeManager> htFem = StaticCast<HtFrameExchangeManager> (m_qosFem);
-          mpdu = htFem->GetMsduAggregator ()->GetNextAmsdu (peekedItem, txParams, availableTime, peekedIt);
+          mpdu = htFem->GetMsduAggregator ()->GetNextAmsdu (peekedItem, txParams, availableTime);
         }
 
       if (mpdu != 0)
@@ -498,14 +495,12 @@
 
   if (mpdu == 0)
     {
-      mpdu = *peekedIt;
-      peekedIt++;
+      mpdu = peekedItem->GetItem ();
     }
 
   // Assign a sequence number if this is not a fragment nor a retransmission
   AssignSequenceNumber (mpdu);
   NS_LOG_DEBUG ("Got MPDU from EDCA queue: " << *mpdu);
-  queueIt = peekedIt;
 
   return mpdu;
 }
@@ -608,10 +603,10 @@
       // Add BA Response is received. In this case, the starting sequence number
       // shall be set equal to the sequence number of such packet.
       uint16_t startingSeq = m_txMiddle->GetNextSeqNumberByTidAndAddress (tid, recipient);
-      WifiMacQueue::ConstIterator peekedIt = m_queue->PeekByTidAndAddress (tid, recipient);
-      if (peekedIt != m_queue->end () && (*peekedIt)->GetHeader ().IsRetry ())
+      auto peekedItem = m_queue->PeekByTidAndAddress (tid, recipient);
+      if (peekedItem != nullptr && peekedItem->GetHeader ().IsRetry ())
         {
-          startingSeq = (*peekedIt)->GetHeader ().GetSequenceNumber ();
+          startingSeq = peekedItem->GetHeader ().GetSequenceNumber ();
         }
       m_baManager->UpdateAgreement (respHdr, recipient, startingSeq);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/qos-txop.h ns-3.36/src/wifi/model/qos-txop.h
--- ns-3.35/src/wifi/model/qos-txop.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/qos-txop.h	2022-04-30 18:23:58.210735000 -0700
@@ -303,38 +303,22 @@
    */
   uint16_t PeekNextSequenceNumberFor (const WifiMacHeader *hdr);
   /**
-   * Peek the next frame to transmit to the given receiver and of the given
-   * TID from the block ack manager retransmit queue first and, if not found, from
-   * the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
-   * is the broadcast address, the first available frame is returned.
-   * Note that A-MSDU aggregation is never attempted (this is relevant if the
-   * frame is peeked from the EDCA queue). If the frame is peeked from the EDCA
-   * queue, it is assigned a sequence number peeked from MacTxMiddle.
+   * Peek the next frame to transmit to the given receiver and of the given TID
+   * from the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
+   * is the broadcast address, the first available frame is returned. If <i>item</i>
+   * is not a null pointer, the search starts from the packet following <i>item</i>
+   * in the queue; otherwise, the search starts from the head of the queue.
+   * Note that A-MSDU aggregation is never attempted. If the frame has never been
+   * transmitted, it is assigned a sequence number peeked from MacTxMiddle.
    *
    * \param tid traffic ID.
    * \param recipient the receiver station address.
+   * \param item the item after which the search starts from
    * \returns the peeked frame.
    */
   Ptr<const WifiMacQueueItem> PeekNextMpdu (uint8_t tid = 8,
-                                            Mac48Address recipient = Mac48Address::GetBroadcast ());
-  /**
-   * Peek the next frame to transmit to the given receiver and of the given
-   * TID from the block ack manager retransmit queue first and, if not found, from
-   * the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
-   * is the broadcast address, the first available frame is returned.
-   * Note that A-MSDU aggregation is never attempted (this is relevant if the
-   * frame is peeked from the EDCA queue). If the frame is peeked from the EDCA
-   * queue, it is assigned a sequence number peeked from MacTxMiddle.
-   *
-   * \param queueIt the QueueIteratorPair pointing to the queue item from which the
-   *                search for an MPDU starts, if the QueueIteratorPair is valid
-   * \param tid traffic ID.
-   * \param recipient the receiver station address.
-   * \returns the peeked frame.
-   */
-  Ptr<const WifiMacQueueItem> PeekNextMpdu (WifiMacQueueItem::ConstIterator queueIt,
-                                            uint8_t tid = 8,
-                                            Mac48Address recipient = Mac48Address::GetBroadcast ());
+                                            Mac48Address recipient = Mac48Address::GetBroadcast (),
+                                            Ptr<const WifiMacQueueItem> item = nullptr);
   /**
    * Prepare the frame to transmit starting from the MPDU that has been previously
    * peeked by calling PeekNextMpdu. A frame is only returned if it meets the
@@ -351,14 +335,10 @@
                           (including protection and acknowledgment); a value of
    *                      Time::Min() indicates no time constraint
    * \param initialFrame true if the frame is the initial PPDU of a TXOP
-   * \param[out] queueIt a queue iterator pointing to the queue item following the
-   *                     last item used to prepare the returned MPDU, if any; if no MPDU
-   *                     is returned, its value is unchanged
    * \return the frame to transmit or a null pointer if no frame meets the time constraints
    */
   Ptr<WifiMacQueueItem> GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                                     Time availableTime, bool initialFrame,
-                                     WifiMacQueueItem::ConstIterator& queueIt);
+                                     Time availableTime, bool initialFrame);
 
   /**
    * Assign a sequence number to the given MPDU, if it is not a fragment
@@ -486,7 +466,6 @@
   uint8_t m_blockAckThreshold;                          /**< the block ack threshold (use BA mechanism if number of packets in queue reaches
                                                              this value. If this value is 0, block ack is never used. When A-MPDU is enabled,
                                                              block ack mechanism is used regardless of this value) */
-  Time m_currentPacketTimestamp;                        //!< the current packet timestamp
   uint16_t m_blockAckInactivityTimeout;                 //!< the BlockAck inactivity timeout value (in TUs, i.e. blocks of 1024 microseconds)
   Time m_startTxop;                                     //!< the start TXOP time
   Time m_txopDuration;                                  //!< the duration of a TXOP
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/aarfcd-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/aarfcd-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -325,10 +325,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -345,7 +346,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -355,8 +355,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/aarf-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/aarf-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/aarf-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/aarf-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -257,10 +257,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -277,7 +278,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -287,8 +287,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/amrr-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/amrr-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -369,10 +369,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, rateIndex);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -388,7 +389,6 @@
       channelWidth = 20;
     }
   UpdateMode (station);
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -398,8 +398,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/aparf-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/aparf-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -376,7 +376,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -386,8 +385,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/arf-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/arf-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/arf-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/arf-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -234,10 +234,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -254,7 +255,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -264,8 +264,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/cara-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/cara-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/cara-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/cara-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -207,10 +207,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -227,7 +228,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -237,8 +237,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/ideal-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/ideal-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -525,12 +525,14 @@
     {
       guardInterval = 800;
     }
-  if (m_currentRate != maxMode.GetDataRate (channelWidth, guardInterval, selectedNss))
+  WifiTxVector bestTxVector {maxMode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (maxMode.GetModulationClass (), GetShortPreambleEnabled ()), guardInterval, GetNumberOfAntennas (), selectedNss, 0, GetChannelWidthForTransmission (maxMode, channelWidth), GetAggregation (station)};
+  uint64_t maxDataRate = maxMode.GetDataRate (bestTxVector);
+  if (m_currentRate != maxDataRate)
     {
-      NS_LOG_DEBUG ("New datarate: " << maxMode.GetDataRate (channelWidth, guardInterval, selectedNss));
-      m_currentRate = maxMode.GetDataRate (channelWidth, guardInterval, selectedNss);
+      NS_LOG_DEBUG ("New datarate: " << maxDataRate);
+      m_currentRate = maxDataRate;
     }
-  return WifiTxVector (maxMode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (maxMode.GetModulationClass (), GetShortPreambleEnabled ()), guardInterval, GetNumberOfAntennas (), selectedNss, 0, GetChannelWidthForTransmission (maxMode, channelWidth), GetAggregation (station));
+  return bestTxVector;
 }
 
 WifiTxVector
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -908,13 +908,14 @@
                          "," << GetChannelWidth (station) << ")");
         }
       WifiMode mode = GetMcsSupported (station, mcsIndex);
-      uint64_t dataRate = mode.GetDataRate (group.chWidth, group.gi, group.streams);
+      WifiTxVector txVector {mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), group.gi, GetNumberOfAntennas (), group.streams, GetNess (station), GetChannelWidthForTransmission (mode, group.chWidth), GetAggregation (station) && !station->m_isSampling};
+      uint64_t dataRate = mode.GetDataRate (txVector);
       if (m_currentRate != dataRate && !station->m_isSampling)
         {
           NS_LOG_DEBUG ("New datarate: " << dataRate);
           m_currentRate = dataRate;
         }
-      return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), group.gi, GetNumberOfAntennas (), group.streams, GetNess (station), GetChannelWidthForTransmission (mode, group.chWidth), GetAggregation (station) && !station->m_isSampling);
+      return txVector;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -374,10 +374,11 @@
       CheckInit (station);
     }
   WifiMode mode = GetSupported (station, station->m_txrate);
-  if (m_currentRate != mode.GetDataRate (channelWidth) && !station->m_isSampling)
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate && !station->m_isSampling)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -392,7 +393,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -402,8 +402,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/onoe-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/onoe-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/onoe-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/onoe-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -331,10 +331,11 @@
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, rateIndex);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -350,7 +351,6 @@
       channelWidth = 20;
     }
   UpdateMode (station);
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -360,8 +360,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/parf-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/parf-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/parf-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/parf-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -348,7 +348,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -358,8 +357,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/rraa-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/rraa-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/rraa-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/rraa-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -356,10 +356,11 @@
     }
   CheckInit (station);
   WifiMode mode = GetSupported (station, station->m_rateIndex);
-  if (m_currentRate != mode.GetDataRate (channelWidth))
+  uint64_t rate = mode.GetDataRate (channelWidth);
+  if (m_currentRate != rate)
     {
-      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
-      m_currentRate = mode.GetDataRate (channelWidth);
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
     }
   return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
@@ -374,7 +375,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -384,8 +384,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 bool
